package cn.iocoder.yudao.module.system.api.user;

import cn.iocoder.yudao.framework.common.util.collection.CollectionUtils;
import cn.iocoder.yudao.module.system.api.user.dto.AdminUserRespDTO;
import cn.iocoder.yudao.module.system.api.user.dto.UserDTO;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.Map;

/**
 * Admin 用户 API 接口
 *
 * @author 芋道源码
 */
public interface AdminUserApi {

    /**
     * 创建用户
     * @author vinjor-M
     * @date 15:27 2024/8/3
     * @param userDTO 用户DTO
     * @return java.lang.Long
    **/
    Long createUser(UserDTO userDTO);

    /**
     * 删除用户
     *
     * @param id 用户编号
     */
    void deleteUser(Long id);

    /**
     * 通过用户 ID 查询用户
     *
     * @param id 用户ID
     * @return 用户对象信息
     */
    AdminUserRespDTO getUser(Long id);

    /**
     * 根据openid和租户id查询用户
     * @author vinjor-M
     * @date 11:29 2024/9/24
     * @param openId 微信id
    * @param tenantId 租户id，可能为null
     * @return cn.iocoder.yudao.module.system.api.user.dto.AdminUserRespDTO
    **/
    AdminUserRespDTO getUserByOpenId(String openId,String tenantId);

    /**
     * 通过用户 登录账户 查询用户---自动拼租户
     *
     * @param username 用户登录账户
     * @return 用户对象信息
     */
    AdminUserRespDTO getUserByUsername(String username);
    /**
     * 通过用户 登录账户 查询用户---不带租户
     *
     * @param username 用户登录账户
     * @return 用户对象信息
     */
    AdminUserRespDTO getUserByUsernameNoTenantId(String username);

    /**
     * 通过用户 ID 查询用户下属
     *
     * @param id 用户编号
     * @return 用户下属用户列表
     */
    List<AdminUserRespDTO> getUserListBySubordinate(Long id);

    /**
     * 通过用户 ID 查询用户们
     *
     * @param ids 用户 ID 们
     * @return 用户对象信息
     */
    List<AdminUserRespDTO> getUserList(Collection<Long> ids);

    /**
     * 获得指定部门的用户数组
     *
     * @param deptIds 部门数组
     * @return 用户数组
     */
    List<AdminUserRespDTO> getUserListByDeptIds(Collection<Long> deptIds);

    /**
     * 获得指定岗位的用户数组
     *
     * @param postIds 岗位数组
     * @return 用户数组
     */
    List<AdminUserRespDTO> getUserListByPostIds(Collection<Long> postIds);

    /**
     * 获得用户 Map
     *
     * @param ids 用户编号数组
     * @return 用户 Map
     */
    default Map<Long, AdminUserRespDTO> getUserMap(Collection<Long> ids) {
        List<AdminUserRespDTO> users = getUserList(ids);
        return CollectionUtils.convertMap(users, AdminUserRespDTO::getId);
    }

    /**
     * 校验用户是否有效。如下情况，视为无效：
     * 1. 用户编号不存在
     * 2. 用户被禁用
     *
     * @param id 用户编号
     */
    default void validateUser(Long id) {
        validateUserList(Collections.singleton(id));
    }

    /**
     * 校验用户们是否有效。如下情况，视为无效：
     * 1. 用户编号不存在
     * 2. 用户被禁用
     *
     * @param ids 用户编号数组
     */
    void validateUserList(Collection<Long> ids);

    /**
     * 重置密码
     * @author 小李
     * @date 16:39 2024/8/9
     * @param id 用户ID
     * @param password 新密码
    **/
    void resetPassword(Long id, String password);

    /**
     * 根据角色编码获取用户集合
     * @param roleCode
     * @param searchValue
     * @param deptIds
     * @return
     */
    List<AdminUserRespDTO> getUsersByRoleRescue(String roleCode,String  searchValue,List<String> deptIds);
    /**
     * 通过用户 手机号 查询用户
     *
     * @param mobile 用户手机号
     * @return 用户对象信息
     */
    AdminUserRespDTO getUserByMobile(String mobile);

    /**
     * 设置用户openId
     * @author vinjor-M
     * @date 15:45 2024/9/24
     * @param userId 用户id
    * @param openId 微信id
    **/
    void setOpenId(Long userId,String openId);

}
